# Example: Android Native Library makefile for paho.mqtt.c
# contributed by Bin Li <bin.li@windriver.com>

LOCAL_PATH := $(call my-dir)
libpaho-mqtt3_lib_path := ../src
libpaho-mqtt3_c_includes := $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path) \
$(LOCAL_PATH)/../../../external/boringssl/include \

LOCAL_CFLAGS := -g -Wno-unused-parameter -Wno-unused-variable

libpaho-mqtt3_local_src_c_files_common := \
$(libpaho-mqtt3_lib_path)/MQTTTime.c \
$(libpaho-mqtt3_lib_path)/MQTTProperties.c \
$(libpaho-mqtt3_lib_path)/WebSocket.c \
$(libpaho-mqtt3_lib_path)/SHA1.c \
$(libpaho-mqtt3_lib_path)/MQTTProtocolClient.c \
$(libpaho-mqtt3_lib_path)/Tree.c \
$(libpaho-mqtt3_lib_path)/Heap.c \
$(libpaho-mqtt3_lib_path)/MQTTPacket.c \
$(libpaho-mqtt3_lib_path)/Clients.c \
$(libpaho-mqtt3_lib_path)/Thread.c \
$(libpaho-mqtt3_lib_path)/utf-8.c \
$(libpaho-mqtt3_lib_path)/StackTrace.c \
$(libpaho-mqtt3_lib_path)/MQTTProtocolOut.c \
$(libpaho-mqtt3_lib_path)/Socket.c \
$(libpaho-mqtt3_lib_path)/Log.c \
$(libpaho-mqtt3_lib_path)/Messages.c \
$(libpaho-mqtt3_lib_path)/LinkedList.c \
$(libpaho-mqtt3_lib_path)/MQTTPersistence.c \
$(libpaho-mqtt3_lib_path)/MQTTPacketOut.c \
$(libpaho-mqtt3_lib_path)/SocketBuffer.c \
$(libpaho-mqtt3_lib_path)/MQTTPersistenceDefault.c \



libpaho-mqtt3_local_src_c_files_base64 := \
$(libpaho-mqtt3_lib_path)/Base64.c \



libpaho-mqtt3_local_src_c_files_c := \
$(libpaho-mqtt3_lib_path)/MQTTClient.c \



libpaho-mqtt3_local_src_c_files_cs := \
$(libpaho-mqtt3_lib_path)/MQTTClient.c \
$(libpaho-mqtt3_lib_path)/SSLSocket.c \



libpaho-mqtt3_local_src_c_files_a := \
$(libpaho-mqtt3_lib_path)/MQTTAsync.c \
$(libpaho-mqtt3_lib_path)/MQTTAsyncUtils.c \



libpaho-mqtt3_local_src_c_files_as := \
$(libpaho-mqtt3_lib_path)/MQTTAsync.c \
$(libpaho-mqtt3_lib_path)/MQTTAsyncUtils.c \
$(libpaho-mqtt3_lib_path)/SSLSocket.c \



# update the header file which normally generated by cmake
$(shell (cp -f $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)/VersionInfo.h.in $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)/VersionInfo.h))
$(shell (sed -i "s/@CLIENT_VERSION@/1.3.9/g" $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)/VersionInfo.h))
$(shell ( sed -i "s/@BUILD_TIMESTAMP@/$(shell date)/g" $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)/VersionInfo.h))



include $(CLEAR_VARS)
LOCAL_MODULE := libpaho-mqtt3c
LOCAL_SHARED_LIBRARIES := libdl
LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)
LOCAL_CFLAGS := -g -Wno-unused-parameter -Wno-unused-variable
LOCAL_C_INCLUDES:= $(libpaho-mqtt3_c_includes)
LOCAL_SRC_FILES := $(libpaho-mqtt3_local_src_c_files_common) $(libpaho-mqtt3_local_src_c_files_c) $(libpaho-mqtt3_local_src_c_files_base64)
LOCAL_MODULE_TAG := optional
LOCAL_VENDOR_MODULE := true
include $(BUILD_SHARED_LIBRARY)



include $(CLEAR_VARS)
LOCAL_MODULE := libpaho-base64cs
LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)
LOCAL_C_INCLUDES:= $(libpaho-mqtt3_c_includes)
LOCAL_CFLAGS := -g -Wno-unused-parameter -Wno-unused-variable
LOCAL_SRC_FILES := $(libpaho-mqtt3_local_src_c_files_base64)
LOCAL_MODULE_TAG := optional
LOCAL_VENDOR_MODULE := true
include $(BUILD_STATIC_LIBRARY)




include $(CLEAR_VARS)
LOCAL_MODULE := libpaho-mqtt3cs
LOCAL_STATIC_LIBRARIES := libpaho-base64cs
LOCAL_SHARED_LIBRARIES := libcrypto libssl libdl
LOCAL_EXPORT_C_INCLUDE_DIRS := $(LOCAL_PATH)/$(libpaho-mqtt3_lib_path)
LOCAL_C_INCLUDES:= $(libpaho-mqtt3_c_includes)
LOCAL_CFLAGS := -g -Wno-unused-parameter -Wno-unused-variable
LOCAL_CFLAGS += -DOPENSSL
LOCAL_SRC_FILES := $(libpaho-mqtt3_local_src_c_files_common) $(libpaho-mqtt3_local_src_c_files_cs)
LOCAL_MODULE_TAG := optional
LOCAL_VENDOR_MODULE := true
include $(BUILD_SHARED_LIBRARY)




# build sample util
define build_sample_util
__sample_module:= $1
__sample_lib:= $2
include $(CLEAR_VARS)
LOCAL_C_INCLUDES := $(libpaho-mqtt3_c_includes)
LOCAL_SHARED_LIBRARIES := $$(__sample_lib)
LOCAL_CFLAGS := -g -Wno-unused-parameter -Wno-unused-variable
LOCAL_MODULE := $$(__sample_module)
LOCAL_SRC_FILES := $(libpaho-mqtt3_lib_path)/samples/$$(__sample_module).c
LOCAL_SRC_FILES += $(libpaho-mqtt3_lib_path)/samples/pubsub_opts.c
LOCAL_SRC_FILES += $(libpaho-mqtt3_lib_path)/MQTTReasonCodes.c
LOCAL_MODULE_TAG := optional
LOCAL_VENDOR_MODULE := true
include $(BUILD_EXECUTABLE)
endef



#$(eval $(call build_sample_util, paho_cs_pub, libpaho-mqtt3cs ) )
#$(eval $(call build_sample_util, paho_cs_sub, libpaho-mqtt3cs ) )
$(eval $(call build_sample_util, paho_cs_pub, libpaho-mqtt3c ) )
$(eval $(call build_sample_util, paho_cs_sub, libpaho-mqtt3c ) )
